/* eslint-disable quotes */
import { systemList } from "./system";
// import { DwHttpApiInterceptor } from "@webdpt/framework/http";
/* eslint-disable quotes */
import { Component, OnInit } from "@angular/core";
import {
  DigiMiddlewareAuthApp,
  DigiMiddlewareAuthUser,
} from "app/config/app-auth-token";
import { CommonService } from "../service/common.service";
import { log } from "console";
import { menuData } from './../menu/model/menu.model';

@Component({
  selector: "app-layout",
  templateUrl: "./layout.component.html",
  styleUrls: ["./layout.component.less"],
})
export class LayoutComponent implements OnInit {
  // 登出： https://iam-test.digiwincloud.com.cn/api/iam/v2/identity/logout
  userToken: string;
  systemMaps = {};
  user_info = {
    userId: "", // 当前用户账号
    tenantId: "", // 当前用户租户id
    productKey: "", // json字段的头部
  };
  queryDisplayList = [];
  constructor(private commonService: CommonService) { }
  ngOnInit(): void {
    this.systemMaps = systemList;
    this.initSystemBySemcSSO();
  }


  /**
   * 通过请求queryDisplayList接口登录
   */
  initSystemBySemcSSO() {
    const headers = {
      "Digi-Middleware-Auth-App": DigiMiddlewareAuthApp,
      "Digi-Middleware-Auth-User": DigiMiddlewareAuthUser,
    };
    const url = this.commonService.semcUrl + "/tenant/semc/applink/queryDisplayList";
    this.commonService.getRequestWithHeaders(url, headers).then((res) => {
      this.queryDisplayList = res.response;
      this.queryDisplayList.forEach(item => {
        this.systemMaps["SSO_" + item.id] = {
          key: item.id,
          id: item.id,
          title: item.name,
          mockLogin: false,
          ssoLogin: true,
          callBackUrl: item.callBackUrl,
          url: item.cloudwebsite,
          applicationAppId: item.applicationAppId
        };
      });
      console.log("systemMaps", this.systemMaps);
    }).catch((error) => console.error(error));
  }


  jumpToSystem(key: string) {

    console.log(this.systemMaps);
    if (this.systemMaps[key] == null) {
      return;
    }

    const item = this.systemMaps[key];

    // 免密跳转
    if (item.linkLogin) {
      window.open(item.url,'_blank');
      return;
    }

    const DwUserInfo = JSON.parse(sessionStorage.getItem("DwUserInfo"));

    const headers = {
      "Digi-Middleware-Auth-App": DigiMiddlewareAuthApp,
      "Digi-Middleware-Auth-User": DigiMiddlewareAuthUser,
    };

    // 单点登录
    if (item.ssoLogin) {

      this.commonService.postWithHeaders(this.commonService.iamUrl + "/api/iam/v2/oauth2/authorize",
        {
          "appId": item.applicationAppId,
          "callbackUrl": item.callBackUrl
        },
        headers
      ).then(res => {
        if (res && res.data && res.data.code) {
          window.open(item.url + "&code=" + res.data.code);
        }
      });
      return;
    }

    // 模拟登录
    if (item.mockLogin) {

      this.commonService.postWithHeaders(this.commonService.apiUrl + "/restful/standard/demo/api/default/login",
        {
          userId: DwUserInfo.userId,
          tenantId: DwUserInfo.tenantId,
          productKey: item.id
        }, headers
      ).then(res => {
        if (res && res.response) {
          window.open(item.url + "/sso-login?userToken=" + res.response.user_token);
        }
      });

    } else {

      // 切换租户登录
      this.commonService.postWithHeaders(this.commonService.iamUrl + "/api/iam/v2/identity/token/refresh/tenant",
        { tenantSid: item.sid },
        headers
      ).then(res => {
        if (res) {
          window.open(item.url + "/sso-login?userToken=" + res.user_token);
        }
      });
    }
  }

}
